﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace GetFieldsListAndSetStyles
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = CreateTable(4, 50);
        }

        private void XamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            foreach (Field field in e.FieldLayout.Fields)
            {
                switch (field.Name)
                {
                    case "Column 0":
                        field.Settings.CellValuePresenterStyle = LayoutRoot.Resources["style1"] as Style;
                        break;
                    case "Column 1":
                        field.Settings.CellValuePresenterStyle = LayoutRoot.Resources["style2"] as Style;
                        break;
                    case "Column 2":
                        field.Settings.CellValuePresenterStyle = LayoutRoot.Resources["style3"] as Style;
                        break;
                    case "Column 3":
                        field.Settings.CellValuePresenterStyle = LayoutRoot.Resources["style4"] as Style;
                        break;
                    default:
                        break;
                }
            }
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column " + j] = r.Next(1000 * i);
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void XamDataGrid_Loaded(object sender, RoutedEventArgs e)
        {
            string fields = "Fields:\n";

            foreach (Field field in (sender as XamDataGrid).FieldLayouts[0].Fields)
            {
                fields += field.Name + "\n";
            }

            MessageBox.Show(fields);
        }

    }


}
